(function($) {
    /**
     * French language package
     * Translated by @dlucazeau
     */
    $.fn.bootstrapValidator.i18n = $.extend(true, $.fn.bootstrapValidator.i18n, {
        base64: {
            'default': 'Veuillez fournir une donnée correctement encodée en Base64'
        },
        between: {
            'default': 'Veuillez fournir une valeur comprise entre %s et %s',
            notInclusive: 'Veuillez fournir une valeur strictement comprise entre %s et %s'
        },
        callback: {
            'default': 'Veuillez fournir une valeur valide'
        },
        choice: {
            'default': 'Veuillez fournir une valeur valide',
            less: 'Veuillez choisir au minimum %s options',
            more: 'Veuillez choisir au maximum %s options',
            between: 'Veuillez choisir de %s à %s options'
        },
        creditCard: {
            'default': 'Veuillez fournir un numéro de carte de crédit valide'
        },
        cusip: {
            'default': 'Veuillez fournir un code CUSIP valide'
        },
        cvv: {
            'default': 'Veuillez fournir un code CVV valide'
        },
        date: {
            'default': 'Veuillez fournir une date valide'
        },
        different: {
            'default': 'Veuillez fournir une valeur différente'
        },
        digits: {
            'default': 'Veuillez ne fournir que des chiffres'
        },
        ean: {
            'default': 'Veuillez fournir un code-barre EAN valide'
        },
        emailAddress: {
            'default': 'Veuillez fournir une adresse mail valide'
        },
        file: {
            'default': 'Veuillez choisir un fichier valide'
        },
        greaterThan: {
            'default': 'Veuillez fournir une valeur supérieure ou égale à %s',
            notInclusive: 'Veuillez fournir une valeur supérieure à %s'
        },
        grid: {
            'default': 'Veuillez fournir un code GRId valide'
        },
        hex: {
            'default': 'Veuillez fournir un nombre hexadécimal valide'
        },
        hexColor: {
            'default': 'Veuillez fournir une couleur hexadécimale valide1'
        },
        iban: {
            'default': 'Veuillez fournir un code IBAN valide',
            countryNotSupported: 'Le code de pays %s n\'est pas accepté',
            country: 'Veuillez fournir un code IBAN sous la forme %s',
            countries: {
                AD: 'Andorre',
                AE: 'Émirats Arabes Unis',
                AL: 'Albanie',
                AO: 'Angola',
                AT: 'Autriche',
                AZ: 'Azerbaijan',
                BA: 'Bosnie-Herzégovine',
                BE: 'Belgique',
                BF: 'Burkina Faso',
                BG: 'Bulgarie',
                BH: 'Bahrein',
                BI: 'Burundi',
                BJ: 'Bénin',
                BR: 'Brésil',
                CH: 'Suisse',
                CI: 'Côte d\'ivoire',
                CM: 'Cameroon',
                CR: 'Costa Rica',
                CV: 'Cap Vert',
                CY: 'Chypre',
                CZ: 'République Tchèque',
                DE: 'Allemagne',
                DK: 'Danemark',
                DO: 'République Dominicaine',
                DZ: 'Algérie',
                EE: 'Estonie',
                ES: 'Espagne',
                FI: 'Finlande',
                FO: 'Îles Féroé',
                FR: 'France',
                GB: 'Royaume Uni',
                GE: 'Géorgie',
                GI: 'Gibraltar',
                GL: 'Groënland',
                GR: 'Gréce',
                GT: 'Guatemala',
                HR: 'Croatie',
                HU: 'Hongrie',
                IE: 'Irlande',
                IL: 'Israël',
                IR: 'Iran',
                IS: 'Islande',
                IT: 'Italie',
                JO: 'Jordanie',
                KW: 'Koweït',
                KZ: 'Kazakhstan',
                LB: 'Liban',
                LI: 'Liechtenstein',
                LT: 'Lithuanie',
                LU: 'Luxembourg',
                LV: 'Lettonie',
                MC: 'Monaco',
                MD: 'Moldavie',
                ME: 'Monténégro',
                MG: 'Madagascar',
                MK: 'Macédoine',
                ML: 'Mali',
                MR: 'Mauritanie',
                MT: 'Malte',
                MU: 'Maurice',
                MZ: 'Mozambique',
                NL: 'Pays-Bas',
                NO: 'Norvège',
                PK: 'Pakistan',
                PL: 'Pologne',
                PS: 'Palestine',
                PT: 'Portugal',
                QA: 'Quatar',
                RO: 'Roumanie',
                RS: 'Serbie',
                SA: 'Arabie Saoudite',
                SE: 'Suède',
                SI: 'Slovènie',
                SK: 'Slovaquie',
                SM: 'Saint-Marin',
                SN: 'Sénégal',
                TN: 'Tunisie',
                TR: 'Turquie',
                VG: 'Îles Vierges britanniques'
            }
        },
        id: {
            'default': 'Veuillez fournir un numéro d\'identification valide',
            countryNotSupported: 'Le code de pays %s n\'est pas accepté',
            country: 'Veuillez fournir un numéro d\'identification %s valide',
            countries: {
                BA: 'Bosnia and Herzegovina',
                BG: 'bulgare',
                BR: 'brésilien',
                CH: 'suisse',
                CL: 'chilien',
                CZ: 'tchéque',
                DK: 'danois',
                EE: 'estonien',
                ES: 'espagnol',
                FI: 'finnois',
                HR: 'croate',
                IE: 'irlandais',
                IS: 'islandais',
                LT: 'lithuanien',
                LV: 'letton',
                ME: 'monténégrin',
                MK: 'macédonien',
                NL: 'hollandais',
                RO: 'roumain',
                RS: 'serbe',
                SE: 'suédois',
                SI: 'slovène',
                SK: 'slovaque',
                SM: 'de Saint-Marin',
                ZA: 'sud-africain'
            }
        },
        identical: {
            'default': 'Veuillez fournir la même valeur'
        },
        imei: {
            'default': 'Veuillez fournir un code IMEI valide'
        },
        imo: {
            'default': 'Veuillez fournir un code IMO valide'
        },
        integer: {
            'default': 'Veuillez fournir un nombre valide'
        },
        ip: {
            'default': 'Veuillez fournir une adresse IP valide',
            ipv4: 'Veuillez fournir une adresse IPv4 valide',
            ipv6: 'Veuillez fournir une adresse IPv6 valide'
        },
        isbn: {
            'default': 'Veuillez fournir un code ISBN valide'
        },
        isin: {
            'default': 'Veuillez fournir un code ISIN valide'
        },
        ismn: {
            'default': 'Veuillez fournir un code ISMN valide'
        },
        issn: {
            'default': 'Veuillez fournir un code ISSN valide'
        },
        lessThan: {
            'default': 'Veuillez fournir une valeur inférieure ou égale à %s',
            notInclusive: 'Veuillez fournir une valeur inférieure à %s'
        },
        mac: {
            'default': 'Veuillez fournir une adresse MAC valide'
        },
        meid: {
            'default': 'Veuillez fournir un code MEID valide'
        },
        notEmpty: {
            'default': 'Veuillez fournir une valeur'
        },
        numeric: {
            'default': 'Veuillez fournir une valeur décimale valide'
        },
        phone: {
            'default': 'Veuillez fournir un numéro de téléphone valide',
            countryNotSupported: 'Le code de pays %s n\'est pas accepté',
            country: 'Veuillez fournir un numéro de téléphone valide pour %s',
            countries: {
                ES: 'las Espagne',
                FR: 'la France',
                GB: 'le Royaume Uni',
                US: 'les USA'
            }
        },
        regexp: {
            'default': 'Veuillez fournir une valeur correspondant au modèle'
        },
        remote: {
            'default': 'Veuillez fournir une valeur valide'
        },
        rtn: {
            'default': 'Veuillez fournir un code RTN valide'
        },
        sedol: {
            'default': 'Veuillez fournir a valid SEDOL number'
        },
        siren: {
            'default': 'Veuillez fournir un numéro SIREN valide'
        },
        siret: {
            'default': 'Veuillez fournir un numéro SIRET valide'
        },
        step: {
            'default': 'Veuillez fournir un écart valide de %s'
        },
        stringCase: {
            'default': 'Veuillez ne fournir que des caractères minuscules',
            upper: 'Veuillez ne fournir que des caractères majuscules'
        },
        stringLength: {
            'default': 'Veuillez fournir une valeur de longueur valide',
            less: 'Veuillez fournir moins de %s caractères',
            more: 'Veuillez fournir plus de %s caractères',
            between: 'Veuillez fournir entre %s et %s caractères'
        },
        uri: {
            'default': 'Veuillez fournir un URI valide'
        },
        uuid: {
            'default': 'Veuillez fournir un UUID valide',
            version: 'Veuillez fournir un UUID version %s number'
        },
        vat: {
            'default': 'Veuillez fournir un code VAT valide',
            countryNotSupported: 'Le code de pays %s n\'est pas accepté',
            country: 'Veuillez fournir un code VAT %s valide',
            countries: {
                AT: 'autrichien',
                BE: 'belge',
                BG: 'bulgare',
                CH: 'suisse',
                CY: 'chypriote',
                CZ: 'tchèque',
                DE: 'allemand',
                DK: 'danois',
                EE: 'estonien',
                ES: 'Spanish',
                FI: 'finnois',
                FR: 'français',
                GB: 'anglais',
                GR: 'grec',
                EL: 'grec',
                HU: 'hongrois',
                HR: 'croate',
                IE: 'irlandais',
                IT: 'italien',
                LT: 'lithuanien',
                LU: 'luxembourgeois',
                LV: 'letton',
                MT: 'maltais',
                NL: 'hollandais',
                NO: 'norvégien',
                PL: 'polonais',
                PT: 'portuguais',
                RO: 'roumain',
                RU: 'russe',
                RS: 'serbe',
                SE: 'suédois',
                SI: 'slovène',
                SK: 'slovaque'
            }
        },
        vin: {
            'default': 'Veuillez fournir un code VIN valide'
        },
        zipCode: {
            'default': 'Veuillez fournir un code postal valide',
            countryNotSupported: 'Le code de pays %s n\'est pas accepté',
            country: 'Veuillez fournir un %s valide',
            countries: {
                CA: 'code postal canadien',
                DK: 'code postal dannois',
                GB: 'code postal anglais',
                IT: 'code postal italien',
                NL: 'code postal hollandais',
                SE: 'code postal suisse',
                SG: 'code postal de Singapour',
                US: 'code zip US'
            }
        }
    });
}(window.jQuery));
